###################################################
### chunk number 1: chunk0
###################################################
library (tclust)
set.seed (100)

## fig 1
  data (geyser2)
  clus <- tkmeans (geyser2, k = 3, alpha = 0.03)

  data (M5data)
  x <- M5data[, 1:2]

  set.seed (100)
  res.a <- tclust (x, k = 3, alpha = 0.1, restr.fact = 1, restr = "eigen",
                   equal.weights = TRUE)
  res.b <- tclust (x, k = 3, alpha = 0.1, restr.fact = 1, restr = "sigma",
                   equal.weights = TRUE)
  res.c <- tclust (x, k = 3, alpha = 0.1, restr.fact = 1, restr = "deter",
                   equal.weights = TRUE)
  res.d <- tclust (x,k = 3, alpha = 0.1, restr.fact = 50, restr = "deter",
                   equal.weights = FALSE)

## fig 2
	set.seed (100)

  mixt <- rbind (
    rmvnorm (360, c (0,   0), diag (2)),
    rmvnorm (540, c (5,  10), diag (2) * 8 - 2),
    rmvnorm (100, c (2.5, 5), diag (2) * 50) )

## fig 3
  set.seed (100)
  clus.1 <- tclust (mixt, k = 3, alpha = 0.0, restr.fact = 50)
  clus.2 <- tclust (mixt, k = 2, alpha = 0.1, restr.fact = 12)

## fig 4
  ctl <- ctlcurves (mixt, k = 1:4, alpha = seq (0, 0.2, by = 0.05), 
                    restr.fact = 50, trace = 0)

## fig 5
  set.seed (100)
    clus.w <- tclust (mixt, k = 3, alpha = 0.1, restr.fact = 1, 
                      equal.weights = TRUE)
    discr.clus.w <- DiscrFact (clus.w)

## fig 6
  data (swissbank)
  fig6.ctl <- ctlcurves (swissbank, k = 1:4, alpha = seq (0, 0.3, by = 0.025), 
  						 trace = 0)
  
  ## fig 7
  fig7.clus <- tclust (swissbank, k = 2, alpha = .1, restr.fact = 50)
  fig7.discrfact <- DiscrFact (fig7.clus, threshold = .000125)

## fig 8
  fig8.clus <- tclust (swissbank, k = 2, alpha = .1, restr.fact = 50)
  fig8.discrfact <- DiscrFact (fig8.clus)
  fig8.pch <- c (rep ("G", 100), rep ("F", 100))
  fig8.condition <- fig8.discrfact$assignfact > log (.000125)


###################################################
### chunk number 2: chunk1
###################################################
#\includegraphics[width=10cm]{Plots_R-chunk1} %1,1

mmar <- c(5.1, 4.1, 4.1, 1.1)
#par (mar = c(5.1, 4.1, 4.1, 0.6))
# 10cm x 10cm 
# c(1,1)

#og <- grey (0.8)
og <- grey (0)

#library (tclust)
#load ("data.rdat")
plot (clus, col = c(og,2:4), tol.lwd = 1, tol.lty = 2)




###################################################
### chunk number 3: chunk2a
###################################################
#\includegraphics[width=10cm]{Plots_R-chunk2a}
	# Figure 2 ##  the M5 Dataset
	library(tclust)
	data(M5data)
	cl <- M5data[, "cluster"]
	plot (M5data[, 1:2], col = cl + 1, pch = cl + 1, main = "The M5data data set")


###################################################
### chunk number 4: chunk2
###################################################
#\includegraphics[width=12cm]{Plots_R-chunk2}
# 14cm x 14cm 
# c(2,2)

old.par <- par(mfrow=c(2,2), mar = c(2.1, 2.1, 3.6, 1.1))
#col <- grey (c(0.8, 0.55, 0.55, 0.55))
plot(res.a, col = c(og,4,2,3), pch = c(1,4,2,3), tol.lty = 2, main="(a) Trimmed k-means")
plot(res.b, col = c(og,4,2,3), pch = c(1,4,2,3), tol.lty = 2, main="(b) Gallegos and Ritter (2005)")
plot(res.c, col = c(og,4,2,3), pch = c(1,4,2,3), tol.lty = 2, main="(c) Gallegos (2002)")
plot(res.d, col = c(og,4,3,2), pch = c(1,4,3,2), tol.lty = 2, main="(d) Garcia-Escudero et al. (2008)")

# plot(res.a, by.cluster = TRUE, col = c(og,2,3,4), pch = c(1,2,3,4), tol.lty = 2, main="(a) tkmeans")
# plot(res.b, by.cluster = TRUE, col = c(og,3,2,4), pch = c(1,2,3,4), tol.lty = 2, main="(b) Gallegos and Ritter")
# plot(res.c, by.cluster = TRUE, col = c(og,4,2,3), pch = c(1,4,2,3), tol.lty = 2, main="(c) Gallegos")
# plot(res.d, by.cluster = TRUE, col = c(og,3,4,2), pch = c(1,3,4,2), tol.lty = 2, main="(d) tclust")

par (old.par)


###################################################
### chunk number 5: chunk3a
###################################################
#%%\includegraphics[width=15cm]{Plots_R-chunk3a}
#%\includegraphics[width=10cm]{Plots_R-chunk3a}

	# Figure 4
	library(tclust)
	set.seed(10)
	x <- rbind ( rmvnorm (200, c(0,0), diag (2)), rmvnorm (200, c(5,0), diag (2)) )

	plot(tclust (x,k = 3, alpha=0.0, restr.fact = 1), xlim = c(-3,9), ylim = c(-6, 6))
	


###################################################
### chunk number 6: chunk3
###################################################
#%\includegraphics[width=14cm]{Plots_R-chunk3}
# 13cm x 9cm
# c(1,2)

old.par <- par(mfrow=c(1,2))#, mar =c (6.1, 4.1, 4.1, 2.1)) #, mar = c(2.1, 2.1, 3.6, 1.1)

plot(clus.1 , by.clust = TRUE, col = c(og,2,3,4), pch = c(1, 2, 3, 4), tol.lty = 2, main.pre = "(a)")
#	mtext (text = "(a)", side = 1, line = 4.5)
plot(clus.2 , by.clust = TRUE, col = c(og,2,3), pch = c(1, 2, 3), tol.lty = 2, main.pre = "(b)")
#	mtext (text = "(b)", side = 1, line = 4.5)
par (old.par)



###################################################
### chunk number 7: chunk4
###################################################
#%\includegraphics[width=10cm]{Plots_R-chunk4} %   1,1
# 8cm x 11cm
# c(1,1)

	old.par <- par (mfrow = c(1,1))#, mar =c (5.1, 4.1, 4.1, 2.1))
	plot(ctl)# , col = 1)
	par (old.par)



###################################################
### chunk number 8: chunk5a
###################################################
#%\includegraphics[width=14cm]{Plots_R-chunk5a}
# 	# Figure 7
# 	data (geyser2)
# 	old.par <- par(mfrow=c(1,2))#, mar =c (6.1, 4.1, 4.1, 1.1))
# 	set.seed (10)
# 	sw1 <- swissbank[,6, drop = FALSE]
# 	sw3 <- swissbank[,c(1,4,6), drop = FALSE]
# 	plot(tkmeans(sw1,k=2,alpha=0.05), pch = 1:3, by.clust = TRUE, jitter = TRUE, tol.lwd = 2, main.pre = "(a)")
# 	plot(tkmeans(sw3,k=3,alpha=0.05), pch = 1:4, by.clust = TRUE, main.pre = "(b)")
# 	par (old.par)
	
	# Figure 7
	data (geyser2)
	old.par <- par(mfrow=c(1,2))#, mar =c (6.1, 4.1, 4.1, 1.1))
	set.seed (10)
	geyser1 <- geyser2[,1, drop = FALSE]
	geyser3 <- cbind(geyser2,rnorm(nrow (geyser2)))
	#plot(tkmeans(geyser1,k=2,alpha=0.03), pch = 1:3, by.clust = TRUE, jitter = TRUE, tol.lwd = 2, main.pre = "(a)")
	plot(tkmeans(geyser1,k=2,alpha=0.03), jitter = TRUE, tol.lwd = 2, main.pre = "(a)")
	#mtext (text = "(a)", side = 1, line = 4.5)
	#plot(tkmeans(geyser3,k=3,alpha=0.03), pch = 1:4, by.clust = TRUE, main.pre = "(b)")
	plot(tkmeans(geyser3,k=3,alpha=0.03), main.pre = "(b)")
	#mtext (text = "(b)", side = 1, line = 4.5)	
	par (old.par)	


###################################################
### chunk number 9: chunk5
###################################################
#%\includegraphics[width=14cm]{Plots_R-chunk5}
# 16cm x 8.5cm
# c(1,3)

	old.par <- par(mfrow=c(1,3), mar = mmar)

	plot (clus.w, col = c(og,2,3,4), tol.lty = 2, main.pre = "(a)")#, xlim = c(-5,12), ylim = c(-5,17))
	plot.DiscrFact.p2 (discr.clus.w, xlim = c(-70,0), main.pre = "(b)")
	plot.DiscrFact.p3 (discr.clus.w, tol.lty = 2, main.pre = "(c)")#, xlim = c(-5,12), ylim = c(-5,17))

	par (old.par)


###################################################
### chunk number 10: chunk6
###################################################
#%\includegraphics[width=10cm]{plots_R-chunk6} %   1,1
# 8cm x 11cm
# c(1,1)

old.par <- par (mfrow = c(1,1), mar = mmar)#, mar =c (5.1, 4.1, 4.1, 1.1))
plot(fig6.ctl)
par (old.par)



###################################################
### chunk number 11: chunk7
###################################################
#%\includegraphics[width=14cm]{plots_R-chunk7}
# 16cm x 8.5cm
# c(1,3)

	#par(mfrow=c(1,3), mar =c (6.1, 4.1, 4.1, 1.1))
	old.par <- par(mfrow=c(1,3), mar = mmar)
	plot (fig7.discrfact, enum = TRUE)
	par (old.par)



###################################################
### chunk number 12: chunk8
###################################################
#%\includegraphics[clip,width=14cm]{plots_R-chunk8}
data (swissbank)
	old.par <- par(mfrow=c(1,3), mar = mmar)#, mar =c (6.1, 4.1, 4.1, 1.1))

	plot(swissbank[,4],swissbank[,6],col="darkgrey",pch=fig8.pch,main="(a) Cluster1",xlab="Distance of the inner frame to lower border", ylab="Length of the diagonal")
	points(swissbank[fig8.clus$cluster==1,4],swissbank[fig8.clus$cluster==1,6],pch=fig8.pch[fig8.clus$cluster==1],col=2)
	idx <- (fig8.clus$cluster==1) & fig8.condition
	points(swissbank[idx, 4],swissbank[idx, 6],pch=1,cex=4,col="blue")
	#mtext (text = "(a)", side = 1, line = 4.5)

	plot(swissbank[,4],swissbank[,6],col="darkgrey",pch=fig8.pch,main="(b) Cluster2",xlab="Distance of the inner frame to lower border", ylab="Length of the diagonal")
	points(swissbank[fig8.clus$cluster==2,4],swissbank[fig8.clus$cluster==2,6],pch=fig8.pch[fig8.clus$cluster==2],col=3)
	idx <- (fig8.clus$cluster==2)&fig8.condition
	points(swissbank[idx ,4],swissbank[idx, 6],pch=1,cex=4,col="blue")
	#mtext (text = "(b)", side = 1, line = 4.5)

	plot(swissbank[,4],swissbank[,6],col="darkgrey",pch=fig8.pch,main="(c) Trimmed",xlab="Distance of the inner frame to lower border", ylab="Length of the diagonal")
	points(swissbank[fig8.clus$cluster==0,4],swissbank[fig8.clus$cluster==0,6],pch=fig8.pch[fig8.clus$cluster==0])
	idx <- (fig8.clus$cluster==0)&fig8.condition
	points(swissbank[idx ,4],swissbank[idx ,6],pch=1,cex=4,col="blue")
	#mtext (text = "(c)", side = 1, line = 4.5)
	par (old.par)


